<template>
  <div class="container">
    <h2 class="title">新增產品</h2>
    <form class="" @submit="formSubmit" enctype="multipart/form-data">
      <div class="form-group">
        <label class="">語言選擇</label>
        <select v-model="lang" class="form-control">
          <option>請選擇語系</option>
          <option value="0">中文</option>
          <option value="1">英文</option>
          <option value="2">德文</option>
          <option value="3">日文</option>
        </select>
      </div>
      <div class="form-group">
        <label class="">款式</label>
        <select v-model="size" class="form-control">
          <option value="0">單色款</option>
          <option value="1">圖案款</option>
        </select>
      </div>
      <div class="form-group">
        <label class="">尺寸</label>
        <select v-model="type" class="form-control">
          <option>請選擇尺寸</option>
          <option value="0">成人</option>
          <option value="1">兒童</option>
          <option value="2">嬰幼</option>
        </select>
      </div>
      <div class="form-group">
        <label>圖片上傳</label>
        <div>
          <input
            type="file"
            class="form-control img-upload"
            ref="file"
            multiple
            @change="onFileChange"
          />
          <div v-if="preview_list.length" class="img-list">
            <div v-for="(item, index) in preview_list" :key="index">
              <img :src="item" />
            </div>
          </div>
        </div>
      </div>
      <div class="form-group">
        <label class="">產品標題</label>
        <input type="text" v-model="title" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">產品名稱</label>
        <input type="text" v-model="name" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">產品材質</label>
        <input type="text" v-model="material" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">產品規格</label>
        <textarea rows="4" cols="50" v-model="spec" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">口罩顏色</label>
        <input type="text" v-model="color" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">口罩用途</label>
        <input type="text" v-model="used" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">適用情況</label>
        <input type="text" v-model="situation" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">保存期限</label>
        <input type="text" v-model="dueday" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">盒裝數量</label>
        <input type="text" v-model="quantity" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">保存方式</label>
        <input type="text" v-model="storageMethod" class="form-control" />
      </div>
      <div class="form-group">
        <label class="">產品介紹</label>
        <input type="textarea" v-model="info" class="form-control" />
      </div>
      <div class="btn-box">
        <button class="btn btn-primary">上傳</button>
      </div>
    </form>
  </div>
</template>
<script>
import axios from "axios";
export default {
  name: "AddProduct",
  data() {
    return {
      lang: "",
      type: "",
      size: "",
      title: "",
      name: "",
      material: "",
      spec: "",
      color: "",
      used: "",
      situation: "",
      dueday: "",
      quantity: "",
      storageMethod: "",
      images: [],
      info: "",
      preview_list: [],
    };
  },
  methods: {
    onFileChange(e) {
      let selectedFile = e.target.files;

      if (!selectedFile.length) {
        return false;
      }

      for (let i = 0; i < selectedFile.length; i++) {
        var reader = new FileReader();
        reader.onload = (e) => {
          this.preview_list.push(e.target.result);
        };
        this.images.push(selectedFile[i]);
        reader.readAsDataURL(selectedFile[i]);
      }
    },
    formSubmit(e) {
      e.preventDefault();

      const config = {
        headers: { "content-type": "multipart/form-data" },
      };

      let formData = new FormData();
      for (let i = 0; i < this.images.length; i++) {
        let file = this.images[i];
        formData.append("images[" + i + "]", file);
      }

      const data = {
        lang: this.lang,
        type: this.type,
        size: this.size,
        title: this.title,
        name: this.name,
        material: this.material,
        spec: this.spec,
        color: this.color,
        used: this.used,
        situation: this.situation,
        dueday: this.dueday,
        quantity: this.quantity,
        info: this.info,
        storageMethod: this.storageMethod,
      };
      console.log(data);
      formData.append("data", JSON.stringify(data));
      // formData.append("productID", productID);
      // formData.append("customerCode", customerCode);
      axios
        .post("http://172.105.205.37:888/api/product/store", formData, config)
        // .post("http://127.0.0.1:8000/api/product/store", formData, config)
        .then(function (response) {
          console.log("response:" + response.status);
          if (response.status == "200") {
            alert("新增成功");
            location.reload();
          }
          // currentObj.success = response.data.success;
        })
        .catch(function (error) {
          // currentObj.output = error;
          console.log(error);
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.container {
  max-width: 650px;
}
.img-list {
  display: flex;
  margin: 10px 0;
  flex-wrap: wrap;
  img {
    height: 150px;
    margin-right: 5px;
    margin-bottom: 5px;
    max-width: inherit;
    border: 1px solid #ced4da;
    border-radius: 0.25rem;
  }
}
.form-group {
  display: flex;
  align-items: flex-start;
  margin-bottom: 15px;
  label {
    min-width: 100px;
    margin-right: 10px;
    text-align: left;
    padding: 0.375rem 0;
  }
  .form-control {
    display: block;
    width: 100%;
    padding: 0.375rem 0.75rem;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    background-color: #fff;
    background-clip: padding-box;
    border: 1px solid #ced4da;
    border-radius: 0.25rem;
    transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;
    &.img-upload {
      background-color: transparent;
      border: none;
      padding: 0.375rem 0;
    }
  }
}
</style>
